undefine(substr)dnl
PGSQL_CONTROL
-- $Id: varbit.m4,v 1.3 2006/04/18 01:24:12 babolo Exp $

--    --
------------------------------
CREATE OR REPLACE FUNCTION bitex0(bit, int4) RETURNS varbit
 AS '$libdir/varbit.so.VMAJOR', 'bitex0'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION bitex0(bit, int4) IS '   ,    0';

CREATE OR REPLACE FUNCTION bitex1(bit, int4) RETURNS varbit
 AS '$libdir/varbit.so.VMAJOR', 'bitex1'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION bitex1(bit, int4) IS '   ,    1';



--  varbit  bool  AND  OR --
---------------------------------------
CREATE OR REPLACE FUNCTION boolor(bit) RETURNS bool
 AS '$libdir/varbit.so.VMAJOR', 'boolor'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION boolor(bit)       IS 'OR    ';

CREATE OR REPLACE FUNCTION booland(bit) RETURNS bool
 AS '$libdir/varbit.so.VMAJOR', 'booland'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION booland(bit)      IS 'AND    ';



--    , ,            --
--    ,    --
------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION public.varbiteq(bit, bit) RETURNS bool
 AS '$libdir/varbit.so.VMAJOR', 'varbiteq'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbiteq(bit, bit)   IS '    ';

CREATE OR REPLACE FUNCTION varbitand(bit, bit) RETURNS varbit
 AS '$libdir/varbit.so.VMAJOR', 'varbitand'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitand(bit, bit)  IS 'AND      ';

CREATE OR REPLACE FUNCTION varbitor(bit, bit) RETURNS varbit
 AS '$libdir/varbit.so.VMAJOR', 'varbitor'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitor(bit, bit)   IS 'OR      ';

CREATE OR REPLACE FUNCTION varbitxor(bit, bit) RETURNS varbit
 AS '$libdir/varbit.so.VMAJOR', 'varbitxor'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitxor(bit, bit)  IS 'XOR      ';

CREATE OR REPLACE FUNCTION varbitrst(bit, bit) RETURNS varbit
 AS '$libdir/varbit.so.VMAJOR', 'varbitrst'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitrst(bit, bit)  IS '$1 AND ~$2,       ';

CREATE OR REPLACE FUNCTION varbitmeq(bit, bit, bit) RETURNS bool
 AS '$libdir/varbit.so.VMAJOR', 'varbitmeq'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitmeq(bit, bit, bit)  IS '$1  $2    $3';

CREATE OPERATOR ==
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = public.varbiteq
     , COMMUTATOR = ==
     )
;
COMMENT ON OPERATOR == (bit, bit)        IS '    ';

CREATE OPERATOR /|
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitand
     , COMMUTATOR = /|
     )
;
COMMENT ON OPERATOR /| (bit, bit)        IS 'AND      ';

CREATE OPERATOR |/
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitor
     , COMMUTATOR = |/
     )
;
COMMENT ON OPERATOR |/ (bit, bit)        IS 'OR      ';

CREATE OPERATOR ^
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitxor
     , COMMUTATOR = ^
     )
;
COMMENT ON OPERATOR ^ (bit, bit)         IS 'XOR      ';

CREATE OPERATOR !
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitrst
     )
;
COMMENT ON OPERATOR ! (bit, bit)         IS '$1 AND ~$2,       ';



--       --
------------------------------------------
CREATE FUNCTION varbit2numstr(varbit, text) RETURNS text
 AS 'DECLARE
        str  text;
        i    RECORD;
     BEGIN
        FOR i IN SELECT bit2num($1)
        LOOP
           IF str IS NULL
           THEN str := i.bit2num;
           ELSE str := str || $2 || i.bit2num;
           END IF;
        END LOOP;
        RETURN str;
     END;
    '
 LANGUAGE 'plpgsql' IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbit2numstr(varbit, text)
 IS '   ,    .    $2'
;
CREATE OR REPLACE FUNCTION varbit2numstr(varbit, text, text) RETURNS text
 AS 'DECLARE
        num      int;
        num_prev int;
        fl       int;
        str      text;
        i        RECORD;
     BEGIN
        num_prev := 0;
        fl := 0;
        FOR i IN SELECT bit2num($1)
        LOOP
           num := i.bit2num;
           IF str IS NULL
           THEN str := num;
           ELSIF num = num_prev + 1 AND fl = 0
           THEN
              str := str || $3;
              fl := 1;
           ELSIF num <> num_prev + 1 AND fl = 1
           THEN
              str := str || num_prev || $2 || num;
              fl := 0;
           ELSIF fl = 0
           THEN str := str || $2 || num;
           END IF;
           num_prev := num;
        END LOOP;
        IF fl = 0
        THEN RETURN str;
        ELSE RETURN str || num;
        END IF;
     END;
    '
 LANGUAGE 'plpgsql' IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbit2numstr(varbit, text, text)
 IS '   ,    .    $2,    $3'
;



-- / varbit --
-----------------------
CREATE OR REPLACE FUNCTION varbit(text) RETURNS varbit
 AS 'DECLARE
        i int;
        r varbit;
        c char;
     BEGIN
        r := ''''::varbit;
        FOR i IN 1..length($1) LOOP
           c := substr($1, i, 1);
           IF c = ''1''
           THEN r := varbitor(r, bitex0(''1''::varbit, i) >> (i - 1));
           ELSIF c <> ''0''
           THEN RAISE EXCEPTION ''"%" is not a valid binary digit'', c;
           END IF;
        END LOOP;
        RETURN r;
     END;
    '
 LANGUAGE 'plpgsql' IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbit(text) IS '   varbit';

CREATE OR REPLACE FUNCTION text(varbit) RETURNS text 
 AS 'DECLARE
        i int;
        t text;
     BEGIN
        t := ''''::text;
        FOR i IN 1..bit_length($1) LOOP
           IF boolor(varbitand($1, (bitex0(''1''::varbit, i) >> (i - 1))))
           THEN t := t || ''1'';
           ELSE t := t || ''0'';
           END IF;
        END LOOP;
        RETURN t;
     END;
    '
 LANGUAGE 'plpgsql' IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbit(text) IS ' varbit  ';



-- ,   --
--------------------------
CREATE OPERATOR /|/
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitxor
     , COMMUTATOR = /|/
     )
;
CREATE OR REPLACE FUNCTION bitreset(varbit, int4) RETURNS varbit
 AS 'SELECT varbitrst($1, num2bit($2))'
 LANGUAGE SQL IMMUTABLE STRICT
;
